﻿Public Class Form1

    Private Function GetEstudantes() As List(Of Estudante)
        Return New List(Of Estudante) From
        {
           New Estudante With {.EstudanteId = 1, .EstudanteNome = "Bianca Lima",
              .CursoId = 3, .EstudanteIdade = 18},
           New Estudante With {.EstudanteId = 2, .EstudanteNome = "Paulo Morgado",
              .CursoId = 1, .EstudanteIdade = 17},
           New Estudante With {.EstudanteId = 3, .EstudanteNome = "Michaela Silva",
              .CursoId = 2, .EstudanteIdade = 16},
           New Estudante With {.EstudanteId = 4, .EstudanteNome = "Maria Ribeiro",
              .CursoId = 1, .EstudanteIdade = 15},
           New Estudante With {.EstudanteId = 5, .EstudanteNome = "José Duarte",
              .CursoId = 2, .EstudanteIdade = 16},
           New Estudante With {.EstudanteId = 6, .EstudanteNome = "Samira Bueno",
              .CursoId = 4, .EstudanteIdade = 16},
           New Estudante With {.EstudanteId = 7, .EstudanteNome = "Sofia Sanches",
              .CursoId = 1, .EstudanteIdade = 15},
           New Estudante With {.EstudanteId = 8, .EstudanteNome = "Humberto Costa",
              .CursoId = 3, .EstudanteIdade = 17},
           New Estudante With {.EstudanteId = 9, .EstudanteNome = "Joana Silveira",
              .CursoId = 4, .EstudanteIdade = 16}
        }
    End Function
    Private Function GetCursos() As List(Of Curso)
        Return New List(Of Curso) From
           {
              New Curso With {.CursoId = 1, .CursoNome = "Química",
                 .CursoDuracao = 12},
              New Curso With {.CursoId = 2, .CursoNome = "Português",
                 .CursoDuracao = 12},
              New Curso With {.CursoId = 3, .CursoNome = "Biologia",
                 .CursoDuracao = 10},
              New Curso With {.CursoId = 4, .CursoNome = "Fisica",
                 .CursoDuracao = 6}
           }
    End Function

    Private Sub btnEstudantes_Click(sender As Object, e As EventArgs) Handles btnEstudantes.Click

        Dim estudantes = GetEstudantes()
        Dim resultadoConsulta = From estudante In estudantes

        lbDados.Items.Clear()
        lbDados.Items.Add("Id" & vbTab & "Nome" & vbTab & vbTab & "Idade" & vbTab & "Curso")

        For Each resultado In resultadoConsulta
            lbDados.Items.Add(resultado.EstudanteId.ToString() & vbTab &
                              resultado.EstudanteNome & vbTab &
                              resultado.EstudanteIdade.ToString() & vbTab &
                              resultado.CursoId.ToString())
        Next

    End Sub

    Private Sub btnCursos_Click(sender As Object, e As EventArgs) Handles btnCursos.Click
        Dim cursos = GetCursos()
        Dim resultadoConsulta = From cour In cursos

        lbDados.Items.Clear()
        lbDados.Items.Add("Id" & vbTab & "Nome" & vbTab & vbTab & "Curso")

        For Each resultado In resultadoConsulta
            lbDados.Items.Add(
                resultado.CursoId.ToString() & vbTab &
                resultado.CursoNome & vbTab & vbTab &
                resultado.CursoDuracao.ToString()
                )
        Next

    End Sub

    Private Sub btnFiltrarAlunosPorCurso_Click(sender As Object, e As EventArgs) Handles btnFiltrarAlunosPorCurso.Click
        Dim estudantes = GetEstudantes()

        Dim msg, titulo, valor As String
        Dim objValor As Object
        msg = "Informe o Id do Curso "
        titulo = "Filtrar por Curso" ' define o titulo.
        valor = "1"            ' define o valor padrao
        ' Exibe mensagem posicionada 

        objValor = InputBox(msg, titulo, valor, 800, 400)

        If (String.IsNullOrEmpty(objValor)) Then
            MessageBox.Show("Operação Cancelada..", "Cancelada")
            Return
        Else
            Dim resultadoConsulta = From estudante In estudantes
                                    Where estudante.CursoId = objValor.ToString

            lbDados.Items.Clear()
            lbDados.Items.Add("Id" & vbTab & "Nome" & vbTab & vbTab & "Idade" & vbTab & "Curso")

            For Each resultado In resultadoConsulta
                lbDados.Items.Add(resultado.EstudanteId.ToString() & vbTab &
                                  resultado.EstudanteNome & vbTab &
                                  resultado.EstudanteIdade.ToString() & vbTab &
                                  resultado.CursoId.ToString())
            Next
        End If
    End Sub

    Private Sub btnFiltrarCursos_Click(sender As Object, e As EventArgs) Handles btnFiltrarCursos.Click
        Dim cursos = GetCursos()

        Dim msg, titulo, valor As String
        Dim objValor As Object
        msg = "Informe o Id do Curso "
        titulo = "Filtrar por Curso" ' define o titulo.
        valor = "1"            ' define o valor padrao

        ' Exibe mensagem posicionada 
        objValor = InputBox(msg, titulo, valor, 800, 400)

        If (String.IsNullOrEmpty(objValor)) Then
            MessageBox.Show("Operação Cancelada..", "Cancelada")
            Return
        Else
            Dim resultadoConsulta = From curso In cursos
                                    Where curso.CursoId = objValor
                                    Order By curso.CursoNome
                                    Select curso.CursoNome, curso.CursoDuracao

            lbDados.Items.Clear()
            lbDados.Items.Add("Nome" & vbTab & vbTab & "Duraçao")

            For Each resultado In resultadoConsulta
                lbDados.Items.Add(
                    resultado.CursoNome & vbTab & vbTab &
                    resultado.CursoDuracao.ToString()
                    )
            Next
        End If
    End Sub

    Private Sub btnCombinarDados_Click(sender As Object, e As EventArgs) Handles btnCombinarDados.Click
        Dim estudantes = GetEstudantes()
        Dim cursos = GetCursos()

        Dim resultadoConsulta = From stu In estudantes, cur In cursos
                                Where stu.CursoId = cur.CursoId
                                Select stu, cur
                                Order By stu.EstudanteNome


        lbDados.Items.Add("Aluno" & vbTab & vbTab & vbTab & "Curso")

        For Each resultado In resultadoConsulta
            lbDados.Items.Add(
                resultado.stu.EstudanteNome & vbTab & vbTab &
                resultado.cur.CursoNome.ToString()
                )
        Next

    End Sub

    Private Sub btnSair_Click(sender As Object, e As EventArgs) Handles btnSair.Click
        If MessageBox.Show("Deseja Encerrar ?", "Encerrar", MessageBoxButtons.YesNo) = DialogResult.Yes Then
            Application.Exit()
        End If
    End Sub
End Class
